; SidWine C64 Online Music Competition vote pgr
; Tognon Stefano
; (c) 2002 Ice Team
;
; dasm source code
;
; sorry for the little fickering, but no idea for do better

 processor 6502
 org 2049

 ;=================================
 ; PRG start address
 ;=================================
 ; dc.b $01,$08

 ;=================================
 ; BASIC startup program
 ;=================================
 dc.b $0b,$08,$e8,$03,$9e,"2061",0,0,0
 org 2061

SCREEN     = $E544    ; clean the screen
SET_COOR   = $E50C    ; set x/y coord
PUT_CHAR   = $E716    ; put a char in the screen
STRING     = $AB1E    ; put a string

      mac write
      ldx  {1}
      ldy  {1}+1
      jsr  SET_COOR
      lda  #<({1}+2)
      ldy  #>({1}+2)
      jsr  STRING
      endm

      jsr initsongs

      lda  #$02                        ; make red color
      sta  53281
      sta  53280
      lda  #144
      jsr  PUT_CHAR
      jsr  SCREEN

      write strTitle
      write strDate
      write strA
      write strB
      write strC
      write strD
      write strE
      write strF
      write strG
      write strH
      write strI
      write strJ
      write strK
      write strL
      write strUp
      write strDn

initraster:
      sei
      lda  #<raster0
      sta  $0314
      lda  #>raster0
      sta  $0315
      lda  #RASTER0                    ;Set low bits of raster
      sta  $d012                       ;position
      lda  $d011
      and  #$7f                        ;Set high bit of raster
      sta  $d011                       ;position (0)
      lda  #$7f                        ;Set timer interrupt off
      sta  $dc0d
                                       ; set NMI on to 60Hz

      lda  #<rasterNMI
      sta  $0318
      lda  #>rasterNMI
      sta  $0319
      lda #$25
      ldx #$40
      sta $dd04
      stx $dd05
      lda #$81
      ldx #$01
      sta $dd0d
      stx $dd0e

      lda  #$01                        ;Set raster interrupt on
      sta  $d01a
      lda  $dc0d                       ;Acknowledge timer interrupt
      cli
repeat:
      jsr  key
      jsr  $EEB3
      jsr  colorLine
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      jsr  $EEB3                       ;delay cycle
      lda  $d012
      cmp  #225
      bpl  skip
      cmp  #210
      bmi  skip
      jsr  colorText

skip: jmp repeat


RASTER0 = 30
RASTER1 = 114

raster0:
      jsr  enableGraphics
      inc  $d019

      lda  #<raster1
      sta  $0314
      lda  #>raster1
      sta  $0315

      lda  #RASTER1                    ;Set low bits of raster
      sta  $d012                       ;position
      lda  $d011
      and  #$7f                        ;Set high bit of raster
      sta  $d011                       ;position (0)

      jmp  $ea81

raster1:
      jsr  disableGraphics
      inc $d019

      lda  #<raster0
      sta  $0314
      lda  #>raster0
      sta  $0315

      lda  #RASTER0                    ;Set low bits of raster
      sta  $d012                       ;position
      lda  $d011
      and  #$7f                        ;Set high bit of raster
      sta  $d011                       ;position (0)

      lda  late
      bne  music
      jmp  $ea81
music:
      lda  #0
      sta  late
      ;inc  53281
      jsr  serviceMusic
      ;dec 53281
      jmp  $ea31

rasterNMI:
      PHA
      TXA
      PHA
      TYA
      PHA
      lda  $dd0d                       ;Acknowledge timer interrupt
      lda  $d012
      cmp  #60
      bmi  ok
      cmp  #125
      bpl  ok
      inc  late
      jmp  exitNMI
ok:
      ;inc  53280
      jsr  serviceMusic
      ;dec 53280
exitNMI:
      jmp  $febc

late: .byte 0            ; <> 0 if we must call service music into raster interrupt

; enable graphics
enableGraphics:             ; set pointer for graphics data
      lda  $d018
      ora  #$08
      and  #$f8
      sta  $d018
                            ; enable bitmap mode standard
      lda  $d011
      ora  #$20
      sta  $d011
      rts

disableGraphics:            ; set pointer for text data
                            ; enable text mode standard
      lda  $d011
      and  #$dF
      sta  $d011

      lda #21
      sta $d018
      lda #8
      sta $d016
      rts

colorLine:                  ; moving color line effect
      ldy $d800+323
      ldx #0
l11:
      lda $d800+324,x
      sta $d800+323,x
      inx
      cpx #33
      bcc l11
      lda $d800+396
      sta $d800+356
      lda $d800+436
      sta $d800+396
      ldx #32
l22:
      lda $d800+403,x
      sta $d800+404,x
      dex
      bpl l22
      lda $d800+363
      sta $d800+403
      sty $d800+363
      rts

colorText:                         ;flashing color text effect
      inc counter
      lda counter
      lsr
      and #15
      tay
      lda txtcol,y
      ldx #39
l1:
      sta $d800+520,x
      sta $d800+560,x
      sta $d800+600,x
      sta $d800+640,x
      sta $d800+680,x
      sta $d800+720,x
      sta $d800+760,x
      sta $d800+800,x
      sta $d800+840,x
      sta $d800+880,x
      sta $d800+920,x
      sta $d800+960,x
      iny
      dex
      bpl l1
      rts

counter: .byte 0
txtcol: .byte 0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,1

strUp: .byte 8,3,  176, 31, 96, 154, 96, 153, 96, 158, 96, 28, 96, 96, 96, 96, 96, 96, 96, 96
       .byte            96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96
       .byte            96, 96, 96 ,96 ,96, 96, 96, 96, 174, 0

strDn: .byte 10,3, 173, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96
       .byte            96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96
       .byte            96, 96, 96 ,96 ,96, 96, 96, 96, 189, 0
strTitle: .byte 9, 3, 98, "C64 ONLINE SID MUSIC COMPETITION", 28, 98, 144, 0
strDate: .byte 11, 15, "APRIL 2002",0
strA: .byte 13, 0, "A: LITTLE GIRL           STEFANO TOGNON",0
strB: .byte 14, 0, "B: HUTLEN                VINCENZO",0
strC: .byte 15, 0, "C: GOPHO                 GOTO80",0
strD: .byte 16, 0, "D: VEHICULAR HELL        WAZ/PADUA",0
strE: .byte 17, 0, "E: WITHOUT A NAME        STEPHAN SCHMIDT",0
strF: .byte 18, 0, "F: BLUENIGHT             GERARD HULTINK",0
strG: .byte 19, 0, "G: A RAINY DAY           H. M. MURDOCK",0
strH: .byte 20, 0, "H: NO MAN ARMY           H. M. MURDOCK",0
strI: .byte 21, 0, "I: IMPROPER C0NNECTIONS  OPAQUE FEAR",0
strJ: .byte 22, 0, "J: ENTER THE DRAGON      OEDIPUS",0
strK: .byte 23, 0, "K: SOULFIXER             LUCA/FIRE",0
strL: .byte 24, 0, "L: PRESSURE COOKER       CREAMD/DMAGIC",0

; read a char from the queue
key:
      jsr  $FFE4
      cmp  #0
      bne  skipExit
Exit:
      rts
skipExit:
      cmp  #65
      bmi  Exit
      cmp  #77
      bpl  Exit
      pha

; stop music
      ldy  #$14
Loop:
      sty  $D418

      ldx  #20
Loop2:
      jsr  $EEB3
      dex
      bne  Loop2
      dey
      bne  Loop

; disable interrupt
      ;jsr $FDA3 ; io init
      ;jsr $FCF8
      ;jsr $E394

      ldx #0                          ; stop NMI and IRQ interrupts
      stx $d01a
      lda $d019
      sta $d019

      lda #$7f
      sta $dd0d
      lda $dd0d
      lda #8
      sta $dd0e

      cli
      lda  #$31
      sta  $314
      lda  #$EA
      sta  $315
      lda  #$47
      sta  $318
      lda  #$FE
      sta  $319
      sei

      lda #$25
      ldx #$40
      sta $dc04
      stx $dc05
      lda #$81
      ldx #$01
      sta $dc0d
      stx $dc0e

      jsr  disableGraphics
      jsr  SCREEN
      lda  #05
      sta  53281
      lda  #06
      sta  53280

; load the needed file
      pla
      sta  nA

                   ; insert the call to load and pgr execute to safe area
      lda  #$20
      sta  $9000
      lda  #$D5
      sta  $9001
      lda  #$FF
      sta  $9002
      lda  #$4C
      sta  $9003
      lda  #$0d
      sta  $9004
      lda  #$08
      sta  $9005

      lda  nA
      cmp  #67
      bne  branch   ; this song has a different starting address: 2049
      lda  #$01
      sta  $9004

branch:
      cmp  #68
      bne  branch2  ; and this 7168
      lda  #$00
      sta  $9004
      lda  #$1C
      sta  $9005

branch2:


branch3:
      cmp  #70
      bne  branch4  ; and this 3584

      lda  #$00
      sta  $9004
      lda  #$0E
      sta  $9005
branch4:
      cmp  #71
      bne  branch5  ; and this 2059
      lda  #$0b
      sta  $9004

branch5:
      cmp  #72
      bne  branch6  ; and this 2059
      lda  #$0b
      sta  $9004

branch6:


branch7:

      jsr  $FFE7   ; clall
      jsr  $FF8A   ; restore

      lda  #$01
      ldx  #$08
      ldy  #$01
      jsr  $FFBA

      lda  #1
      ldx  #<nA
      ldy  #>nA
      jsr  $FFBD

      lda  #$00
      ldx  #$FF
      ldy  #$FF
      jmp  $9000

nA: .byte 0

 org 8192
 .incbin "sidwine.raw"



 org 10752
; Driller by Matt Gray 1997
; estracted from the sid in HVSC
; This portion is copyright by Matt Gray and Incentive

makeMusic:
      lda  songsNumber
      bne  songNotZero
      sta  $D418                  ; Select volume and filter mode (to 0)
      rts

songNotZero:
      cmp  #$AB                   ; current songs ?
      beq  makeCurrent
      jmp  initTr                 ; init the tracks

initMusic:
      lda  #$00                   ; clear control register
      sta  $D404                  ; Voice 1: Control registers
      sta  $D40B                  ; Voice 2: Control registers
      sta  $D412                  ; Voice 3: Control registers

      lda  #$0F                   ; full volume
      sta  $D418                  ; Select volume and filter mode

      ldy  #$00
      sty  offsetTr1              ; set track 1 position to the beginning
      sty  offsetTr2              ; set track 2 position to the beginning
      sty  offsetTr3              ; set track 3 position to the beginning
      sty  actNoteLength          ; actual note length duration voice 1
      sty  actNoteLength+$7       ; actual note length duration voice 2
      sty  actNoteLength+$E       ; actual note length duration voice 3
      sty  ptnInd1                ; set pattern index to the beginning
      sty  ptnInd2
      sty  ptnInd3
      iny
      sty  actSpeed               ; actual cycle timer (speed of song)
      jmp  decCycleTimer

makeCurrent:
      ldy  instrInd,x              ; index of instrument data
      lda  instr1+7,y             ; load instrument effect
      and  #$04                   ; is effect 4?
      beq  noEffect4

; change the control register for making a sound effect
controlEffect:
effect4:
      lda  dur4Eff,x              ; read duration of effect 4 switch
      beq  applyNormalControl

      dec  dur4Eff,x              ; dec duration of effect 4 switch
      lda  instr2+2,y             ; control register
      sta  $D404,x                ; Voice 1: Control registers
      bne  noEffect4

applyNormalControl:
      lda  instr1+1,y             ; control register
      sta  $D404,x                ; Voice 1: Control registers

noEffect4:
      lda  actSpeed               ; actual cycle timer (speed of song)
      bne  noDelayEnd
      dec  actNoteLength,x        ; actual note length duration
      bmi  readPattern            ; jump if note is finished
noDelayEnd:
      jmp  pulseTimbre

; init tracks with selected songs

initTr:
      ldy  songsNumber            ; load song number (1, 2)
      lda  songs+0,y              ; set current track 1
      sta  currentTr1+0           ; current track 1 position (base)
      lda  songs+2,y
      sta  currentTr1+1           ; current track 1 position (base)

      lda  songs+4,y              ; set current track 2
      sta  currentTr2+0           ; current track 2 position (base)
      lda  songs+6,y
      sta  currentTr2+1           ; current track 2 position (base)

      lda  songs+8,y              ; set current track 3
      sta  currentTr3+0           ; current track 3 position (base)
      lda  songs+10,y
      sta  currentTr3+1           ; current track 3 position (base)

      lda  songSpeed,y            ; read the song speed
      sta  speed                  ; cycle timer (speed of song)
      jmp  initMusic

; decrement the cycle timer (speed of song)
decCycleTimer:
      cpx  #$0E                   ; is voice 3 ?
      bne  skipDec                ; no, jump
      dec  actSpeed               ; actual cycle timer (speed of song)
      bpl  skipDec                ; jump if positive
      lda  speed                  ; cycle timer (speed of song)
      sta  actSpeed               ; actual cycle timer (speed of song)
skipDec:
      lda  #$AB                   ; current song
      sta  songsNumber
      rts


; give in FD-FE the pattern pointer to a note
readPattern:
      lda  currentTr1+0,x         ; current track 1 position (base)
      sta  $FB
      lda  currentTr1+1,x         ; current track 1 position (base)
      sta  $FC                    ; FB-FC: track pattern pointer

      ldy  offsetTr1,x            ; read actual track position (offset)
      lda  ($FB),y                ; read actual track pattern pointer value
      tay
      lda  patptl,y               ; read pattern pointer low
      sta  $FD
      lda  patpth,y               ; read pattern pointer high
      sta  $FE                    ; FD-FE: pattern pointer

      lda  #$FF
      sta  controlSwitch          ; on ADS

      lda  #$00
      sta  portaFlag,x            ; no portamento
      sta  insFreqEffFlag,x       ; no inst. freq. effect
      sta  vibratoFlag,x          ; no vibrato

; read the pattern value of note to play
readNextPat:
      ldy  ptnInd,x               ; load pattern index of this voice
      lda  ($FD),y                ; read a pattern value
      cmp  #$FD                   ; note length
      bcc  notFD                  ; jump if <$FD

      iny                         ; next pattern value index
      inc  ptnInd,x               ; next (saved) pattern value index
      lda  ($FD),y                ; read a pattern value (note duration)
      sta  noteLength,x           ; store note length duration

incPtnInd:
      inc  ptnInd,x               ; next (saved) patter value index
      bne  readNextPat
notFD:
      cmp  #$FB
      bcc  notFB                  ; jump if <$FB

      cmp  #$FB
      bne  isFC                   ; jump if <>$FB
;isFB:
      lda  #$01                   ; negative portamento

storePort:
      sta  portaFlag,x            ; store in portamento flag
      iny                         ; next pattern value index
      inc  ptnInd,x               ; next (saved) pattern value index
      lda  ($FD),y                ; read a pattern value
      sta  portaVal,x             ; store pattern value (portamento)

      lda  #$00
      sta  insFreqEffFlag,x       ; no inst. freq. effect
      sta  vibratoFlag,x          ; no vibrato
      beq  incPtnInd

isFC:
      lda  #$02                   ; positive portamento
      bne  storePort              ; store portamento value

notFB:
      cmp  #$FA
      bcc  newNote                ; jump if <$FA

; select new instruments

      iny                         ; next pattern value index
      inc  ptnInd,x               ; next (saved) pattern value index
      lda  ($FD),y                ; read a pattern value (instrument index)

      asl
      asl
      asl                         ; index * 8
      sta  instrInd,x             ; index of instruments data

      tay
      lda  instr1+0,y             ; read Hi/Lo of pulsation amplitude

      pha
      and  #$0F
      sta  hi1Wave,x               ; Wave form pulsation amplitude (hi byte)
      sta  hi2Wave,x               ; Wave form pulsation amplitude (hi byte)
      pla

      and  #$F0
      sta  lo1Wave,x               ; Wave form pulsation amplitude (lo byte)
      sta  lo2Wave,x               ; Wave form pulsation amplitude (lo byte)
      jmp  incPtnInd

newNote:
      sta  rpNote,x                ; store packet note (readed note to play)

      lda  noteLength,x            ; note length duration
      sta  actNoteLength,x         ; actual note length duration

      lda  #$00
      sta  cycleInt,x
      sta  cycleEst,x

      lda  #$02
      sta  dur4Eff,x              ; set duration of effect 4 switch

      ldy  instrInd,x             ; index of instrument data
      lda  instr1+7,y             ; instrument effect
      and  #$02                   ; is effect 2?
      beq  noEffect2

effect2:
      lda  lo2Wave,x              ; Wave form pulsation amplitude (lo byte)
      sta  lo1Wave,x              ; Wave form pulsation amplitude (lo byte)

      lda  hi2Wave,x              ; Wave form pulsation amplitude (hi byte)
      sta  hi1Wave,x              ; Wave form pulsation amplitude (hi byte)

noEffect2:
      lda  rpNote,x               ; readed note to play
      bne  notZero

      lda  pNote,x                ; note to play
      sta  rpNote,x               ; readed note to play
      lda  #$00
      sta  pNote,x                ; note to play
      ldy  instrInd,x             ; index of instrument data
      dec  controlSwitch
      bne  setVoice

notZero:
      sta  pNote,x                ; note to play
      tay

      lda  frequencyHi,y
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)
      sta  freqHi1Eff,x           ; Voice 1: Frequency control (hi byte) for effect 1
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento

      lda  frequencyLo,y
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)
      sta  freqLo1Eff,x           ; Voice 1: Frequency control (lo byte)
      sta  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento

      ldy  instrInd,x             ; index of instrument data
      lda  instr1+6,y             ; control register (ADS off)
      sta  $D404,x                ; Voice 1: Control registers

setVoice:
      lda  instr1+1,y             ; control register
      and  controlSwitch          ; change ADS
      sta  $D404,x                ; Voice 1: Control registers

      lda  instr1+2,y             ; read A/D value
      sta  $D405,x                ; Generator 1: Attack/Decay

      lda  instr1+3,y             ; read S/R value
      sta  $D406,x                ; Generator 1: Sustain/Release

      lda  lo1Wave,x              ; Wave form pulsation amplitude (lo byte)
      sta  $D402,x                ; Voice 1: Wave form pulsation amplitude (lo byte)

      lda  hi1Wave,x              ; Wave form pulsation amplitude (hi byte)
      sta  $D403,x                ; Voice 1: Wave form pulsation amplitude (hi byte)

      inc  ptnInd,x               ; next (saved) pattern value index
      ldy  ptnInd,x               ; load pattern value index
      lda  ($FD),y                ; read a pattern value

      cmp  #$FF                   ; end of pattern
      bne  noEndPattern

endPattern:
      lda  #$00
      sta  ptnInd,x               ; set pattern value index to the beginning

      inc  offsetTr1,x            ; next track position (offset)
      ldy  offsetTr1,x

      lda  ($FB),y                ; read next track pattern pointer
      cmp  #$FF                   ; end of pattern ?
      bne  noEndTrack

endTrack:
      lda  #$00
      sta  offsetTr1,x            ; set track position to the beginning
      beq  noEndPattern

noEndTrack:
      cmp  #$FE                   ; end of song (no repeat)
      bne  noEndPattern

      lda  #$00
      sta  songsNumber            ; nothing song to play
      rts

noEndPattern:
      lda  pNote,x                ; note to play
      beq  pulseTimbre
      ldy  instrInd,x             ; index of instrument data
      lda  portaFlag,x            ; portamento flag
      bne  skipSetPort
      lda  instr2+4,y             ; read portamento flag for the instrument
      beq  skipPortaInstr

      sta  portaFlag,x            ; store portamento flag
      lda  instr2+3,y             ; read portamento value
      sta  portaVal,x             ; portamento value
skipSetPort:
      jmp  testMakePortamento

skipPortaInstr:
      lda  instr1+5,y
      beq  skipInstFreqEffInit
      jmp  instFreqEffInit

skipInstFreqEffInit:
      sta  insFreqEffFlag,x
      lda  instr2+0,y             ; read oscillating frequency value
      beq  noOscEffect
      jmp  vibratoInit

noOscEffect:
      sta  vibratoFlag,x          ; no vibrato
      jmp  decCycleTimer

;pulse-width timbre routine
pulseTimbre:
      lda  instr1+4,y             ; Wave amplitude inc/dec value
      sta  ampVar                 ; store for late use
      beq  afterWaveShifting

      lda  pulseDirFlag,x
      bne  decWave
      clc
      lda  lo1Wave,x              ; Wave form pulsation amplitude (lo byte)
      adc  ampVar
      sta  lo1Wave,x              ; Wave form pulsation amplitude (lo byte)
      sta  $D402,x                ; Voice 1: Wave form pulsation amplitude (lo byte)

      lda  hi1Wave,x              ; Wave form pulsation amplitude (hi byte)
      adc  #$00
      sta  hi1Wave,x              ; Wave form pulsation amplitude (hi byte)
      sta  $D403,x                ; Voice 1: Wave form pulsation amplitude (hi byte)

      clc
      cmp  #$0E
      bcc  afterWaveShifting
      inc  pulseDirFlag,x
      bne  afterWaveShifting

decWave:
      lda  lo1Wave,x             ; Wave form pulsation amplitude (lo byte)
      sec
      sbc  ampVar
      sta  lo1Wave,x             ; Wave form pulsation amplitude (lo byte)
      sta  $D402,x               ; Voice 1: Wave form pulsation amplitude (lo byte)

      lda  hi1Wave,x             ; Wave form pulsation amplitude (hi byte)
      sbc  #$00
      sta  hi1Wave,x             ; Wave form pulsation amplitude (hi byte)
      sta  $D403,x               ; Voice 1: Wave form pulsation amplitude (hi byte)

      clc
      cmp  #$08
      bcs  afterWaveShifting

      dec  pulseDirFlag,x

afterWaveShifting:
      lda  insFreqEffFlag,x
      beq  testVibratoEff

makeInstFreqEff:
      lda  lowInd,x               ; low index for instr. freq. effect
      asl
      tay
      lda  r157A,y
      sta  r0BAA+1
      lda  r157B,y
      sta  r0BAA+2

      lda  actualCycle,x
      cmp  limitCycle,x
      bne  noResetCylce

      lda  #$00
      sta  actualCycle,x

noResetCylce:
      tay
      lda  rpNote,x                ; readed note to play
      clc
r0BAA:
      adc  r157C,y
      tay
      lda  frequencyLo,y
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)
      lda  frequencyHi,y
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)
      inc  actualCycle,x
      jmp  decCycleTimer

testVibratoEff:
      lda  vibratoFlag,x          ; load vibrato flag
      bne  vibratoEffect          ; is to performe vibrato?
      jmp  testMakePortamento

vibratoEffect:
      lda  countVibFlag,x
      beq  sbcVib
      cmp  #$03
      bcc  adcVib

      sec
      lda  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sbc  oscilFreq,x            ; frequency of oscillation
      sta  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)

      lda  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sbc  #$00
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)

      dec  actualVibCount,x
      bne  exitVib1

      lda  vibCount,x             ; read stored value of count
      sta  actualVibCount,x       ; set to actual
      inc  countVibFlag,x
      lda  countVibFlag,x
      cmp  #$05
      bcc  exitVib1

      lda  #$01
      sta  countVibFlag,x
exitVib1:
      jmp  decCycleTimer

sbcVib:
      sec
      lda  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sbc  oscilFreq,x            ; frequency of oscillation
      sta  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)

      lda  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sbc  #$00
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)

      dec  actualVibCount,x
      bne  exitVib2

      lda  vibCount,x             ; read stored count value
      sta  actualVibCount,x
      inc  countVibFlag,x
exitVib2:
      jmp  decCycleTimer

adcVib:
      clc
      lda  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      adc  oscilFreq,x            ; frequency of oscillation
      sta  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)

      lda  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      adc  #$00
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)

      dec  actualVibCount,x
      bne  noEffect1

      lda  vibCount,x             ; read stored count value
      sta  actualVibCount,x
      inc  countVibFlag,x
      bne  noEffect1
      jmp  decCycleTimer

testMakePortamento:
      lda  portaFlag,x            ; portamento flag
      beq  testEffect1

      cmp  #$01                   ; negative portamento
      beq  negativePortamento

      cmp  #$02                   ; positive portamento
      beq  positivePortamento

      cmp  #$03
      beq  negativePortamentoHI
      clc
      lda  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      adc  portaVal,x             ; add portamento value
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)
      jmp  testEffect1

negativePortamento:
      clc
      lda  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sbc  portaVal,x             ; sub portamento value
      sta  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)

      lda  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sbc  #$00
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)
      jmp  testEffect1

negativePortamentoHI:
      sec
      lda  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sbc  portaVal,x             ; sub portamento value
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)
      jmp  testEffect1

positivePortamento:
      clc
      lda  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      adc  portaVal,x             ; add portamento value
      sta  freqPortLo,x           ; Voice 1: Frequency control (lo byte) for portamento
      sta  $D400,x                ; Voice 1: Frequency control (lo byte)

      lda  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      adc  #$00
      sta  freqPortHi,x           ; Voice 1: Frequency control (hi byte) for portamento
      sta  $D401,x                ; Voice 1: Frequency control (hi byte)

testEffect1:
      ldy  instrInd,x             ; index of instrument data
      lda  instr1+7,y             ; load instrument effect
      and  #$01                   ; is effect 1?
      beq  noEffect1
      jmp  effect1

noEffect1:
      jmp  decCycleTimer

;==================================
; Voice 1
;
; vibrato flag: 1= on
;
; portaFlag:
;  1: neg. port. HiLo
;  2: pos. port. HiLo
;  3: neg. port. Hi
;  x: pos. port. Hi
;
; pulseDirFlag: 1 dec, 0 inc
;==================================

vibratoFlag:                      ; vibrato flag (1=on)
  .byte $00

insFreqEffFlag:                   ; 1= effect on
  .byte $00

portaFlag:
  .byte  $00                      ; portamento flag (voice 1)

cycleInt:                         ; internal cycle for effect 1
  .byte $00

cycleEst:                         ; external cycle for effect 1
  .byte $00

ptnInd:
ptnInd1:
  .byte $06                       ; pattern value index (voice 1)

pulseDirFlag:
  .byte $00

;==================================
; Voice 2:
;==================================
  .byte $00
  .byte $00
  .byte $00                       ; portamento flag (voice 2)
  .byte $00
  .byte $00
ptnInd2:
  .byte $06                       ; pattern value index (voice 2)
  .byte $00

;==================================
; Voice 3:
;==================================
  .byte $00
  .byte $00
  .byte $00                       ; portamento flag
  .byte $00
  .byte $00
ptnInd3:
  .byte $00                       ; pattern value index (voice 3)
  .byte $01


;==================================
; Voice 1:
;==================================
portaVal:
  .byte $00                       ; portamento value (voice 1)

r0CE4:                            ; not used
  .byte $00

noteLength:
  .byte $3F                       ; note length duration (voice 1)

instrInd:
  .byte $08                       ; index of instrument data (voice 1)

lo1Wave:
  .byte $BB                       ; Wave form pulsation amplitude (lo byte)

lo2Wave:
  .byte $90                       ; Wave form pulsation amplitude (lo byte)

hi1Wave:
  .byte $02                       ; Wave form pulsation amplitude (hi byte)

;==================================
; Voice 2:
;==================================
  .byte $00                       ; portamento value (Voice 2)
  .byte $00
  .byte $3F                       ; note length duration (voice 2)
  .byte $08                       ; index of instrument data (voice 2)
  .byte $BB                       ; Wave form pulsation amplitude (lo byte)
  .byte $90                       ; Wave form pulsation amplitude (lo byte)
  .byte $02                       ; Wave form pulsation amplitude (hi byte)

;==================================
; Voice 3:
;==================================
  .byte $00                       ; portamento value (voice 3)
  .byte $00
  .byte $3F                       ; note length duration (voice 3)
  .byte $20                       ; index of instrument data (voice 3)
  .byte $F0                       ; Wave form pulsation amplitude (lo byte)
  .byte $90                       ; Wave form pulsation amplitude (lo byte)
  .byte $0C                       ; Wave form pulsation amplitude (hi byte)


;==================================
; Voice 1:
;==================================
hi2Wave:
  .byte $00                       ; Wave form pulsation amplitude (hi byte)

lowInd:                           ; low index for freq. instrument effect
  .byte $00

currentTr1:                       ; current track 1 position (base)
  .byte <drillerMainTr1
  .byte >drillerMainTr1

offsetTr1:                        ; current track 1 position (offset)
  .byte $00

r0CFD:                            ; not used
  .byte $00

actNoteLength:
  .byte $3C                       ; actual note length duration

;==================================
; Voice2:
;==================================
  .byte $00
  .byte $00                       ; low index for freq. instrument effect
currentTr2:                       ; current track 2 position (base)
  .byte <drillerMainTr2
  .byte >drillerMainTr2
offsetTr2:                        ; current track 2 position (offset)
  .byte $00
  .byte $00
  .byte $3C                       ; actual note length duration

;==================================
; Voice 3:
;==================================
  .byte $06
  .byte $00                       ; low index for freq. instrument effect
currentTr3:                       ; current track 3 position (base)
  .byte <drillerMainTr3
  .byte >drillerMainTr3
offsetTr3:                        ; current track 3 position (offset)
  .byte $02
  .byte $00
  .byte $3C                       ; actual note length duration

r0D0D:
  .byte $00
  .byte $00

songsNumber:
  .byte $AB                       ; 0=nothing 1=first, $AB current ?

speed:
  .byte $03                       ; cycle timer (cylce for having 1 note tick)

ampVar:                           ; wave amplitude variation
  .byte $A0

actSpeed:
  .byte $00                       ; actual cycle timer (for having 1 note tick)

controlSwitch:                    ; set ON/OFF the ADS
  .byte $FE


;==================================
; Voice 1
;==================================

freqPortLo:                       ; frequency of portamento lo
  .byte $47                       ; Voice 1: Frequency control (lo byte)

freqLo1Eff:                       ; freq lo for instrument effect 1 ?
  .byte $47                       ; Voice 1: Frequency control (lo byte)

freqHi1Eff:                       ; freq hi for instrument effect 1
  .byte $06                       ; Voice 1: Frequency control (hi byte)

rpNote:
  .byte $1F                       ; Voice 1: readed note to play

freqPortHi:                       ; frequency of portamento Hi
  .byte $06                       ; Voice 1: Frequency control (hi byte)

limitCycle:                       ; limit of cycle for freq. effect
  .byte $00

actualCycle:                      ; actual cycle for freq. effect
  .byte $00

;==================================
; Voice 2
;==================================
  .byte $23                       ; frequency of portamento lo
  .byte $23                       ; freq lo for instrument effect 1 ?
  .byte $03                       ; freq hi for instrument effect 1
  .byte $13                       ; Voice 2: readed note to play
  .byte $03                       ; frequency of portamento Hi
  .byte $00                       ; limit of cycle for freq. effect
  .byte $00                       ; actual cycle for freq. effect

;==================================
; Voice 3
;==================================

  .byte $00                       ; frequency of portamento lo
  .byte $00                       ; freq lo for instrument effect 1 ?
  .byte $00                       ; freq hi for instrument effect 1
  .byte $00                       ; Voice 3: readed note to play
  .byte $00                       ; frequency of portamento Hi
  .byte $00
  .byte $00


;==================================
; Voice 1
;==================================

countVibFlag:                     ; counter flag: use for add/sbc of vibrato
 .byte $00

oscilFreq:                        ; frequency of oscillator (for vibrato)
  .byte $00

vibCount:                         ; value of vibrato count
  .byte $00

actualVibCount:                   ; actual value of vibrato count intensity
  .byte $00

r0D2D:
  .byte $00
  .byte $00

pNote:
  .byte $1F                       ; note to play

;==================================
; Voice 2
;==================================
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $13                       ; note to play

;==================================
; Voice 3
;==================================
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00                       ; note to play


;==================================
; Voice 1
;==================================
dur4Eff:
  .byte $02                       ; duration of effect 4 switch
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

;==================================
; Voice 2
;==================================
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

;==================================
; Voice 3
;==================================
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

; freq. low

frequencyLo:
  .byte $0C, $1C, $2D, $3E        ; C-0 C#-0 D-0 D#-0
  .byte $51, $66, $7B, $91
  .byte $A9, $C3, $DD, $FA
  .byte $18, $38, $5A, $7D
  .byte $A3, $CC, $F6, $23
  .byte $53, $86, $BB, $F4
  .byte $30, $70, $B4, $FB
  .byte $47, $98, $ED, $47
  .byte $A7, $0C, $77, $E9
  .byte $61, $E1, $68, $F7
  .byte $8F, $30, $DA, $8F
  .byte $4E, $18, $EF, $D2
  .byte $C3, $C3, $D1, $EF
  .byte $1F, $60, $B5, $1E
  .byte $9C, $31, $DF, $A5
  .byte $87, $86, $A2, $DF
  .byte $3E, $C1, $6B, $3C
  .byte $39, $63, $BE, $4B
  .byte $0F, $0C, $45, $BF
  .byte $7D, $83, $D6, $79
  .byte $73, $C7, $7C, $97
  .byte $1E, $18, $8B, $7E
  .byte $FA, $06, $AC, $F3
  .byte $E6, $8F, $F8, $2E

frequencyHi:
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $01
  .byte $02, $02, $02, $02
  .byte $02, $02, $02, $03
  .byte $03, $03, $03, $03
  .byte $04, $04, $04, $04
  .byte $05, $05, $05, $06
  .byte $06, $07, $07, $07
  .byte $08, $08, $09, $09
  .byte $0A, $0B, $0B, $0C
  .byte $0D, $0E, $0E, $0F
  .byte $10, $11, $12, $13
  .byte $15, $16, $17, $19
  .byte $1A, $1C, $1D, $1F
  .byte $21, $23, $25, $27
  .byte $2A, $2C, $2F, $32
  .byte $35, $38, $3B, $3F
  .byte $43, $47, $4B, $4F
  .byte $54, $59, $5E, $64
  .byte $6A, $70, $77, $7E
  .byte $86, $8E, $96, $9F
  .byte $A8, $B3, $BD, $C8
  .byte $D4, $E1, $EE, $FD

serviceMusic:
      ldx  #$00                   ; Voice 1
      jsr  makeMusic
      ldx  #$07                   ; Voice 2
      jsr  makeMusic
      ldx  #$0E                   ; Voice 3
      jsr  makeMusic
      rts

  .byte "(C)1987 MATT GRAY"

instFreqEffInit:
      pha
      and  #$0F
      sta  lowInd,x
      pla
      and  #$F0
      lsr
      lsr
      lsr
      lsr
      sta  limitCycle,x

      lda  #$00
      sta  actualCycle,x

      lda  #$01                   ; inst. freq. effect on
      sta  insFreqEffFlag,x

      lda  #$00
      sta  vibratoFlag,x          ; no vibrato
      jmp  decCycleTimer

vibratoInit:
      sta  oscilFreq,x            ; oscillating frequency value
      lda  instr2+1,y             ; read the count intensity for vibrato
      sta  vibCount,x             ; save count value
      sta  actualVibCount,x
      lda  #$00
      sta  insFreqEffFlag,x       ; inst. freq. effect off
      sta  countVibFlag,x

      lda  #$01
      sta  vibratoFlag,x          ; make vibrato
      jmp  decCycleTimer

;=================================
; instruments part 1
; 0: Hi/Lo of Wave form amplitude
; 1: Control register
; 2: A/D value
; 3: S/R value
; 4: Wave amplitude inc/dec value
; 5: hi/lo value for a instr. freq. effect
; 6: Control register
; 7: instrument effect
;    1: a frequency effect
;    2: a wave effect
;    4: switch between waveform (use p1 1 and p2 2)
;=================================

instr1:
  .byte $00                      ; Wave form amplitude (Hi/Lo)
  .byte $81                      ; Control: Noise, ADS on
  .byte $0A                      ; A/D
  .byte $00                      ; S/R
  .byte $00
  .byte $00
  .byte $80                      ; Control: Noise, ADS off
  .byte $01                      ; instrument effect

  .byte $90
  .byte $41
  .byte $FE
  .byte $0D
  .byte $25
  .byte $00
  .byte $40
  .byte $02

  .byte $00
  .byte $81
  .byte $FD
  .byte $00
  .byte $00
  .byte $00
  .byte $80
  .byte $00

  .byte $30
  .byte $41
  .byte $0E
  .byte $00
  .byte $30
  .byte $00
  .byte $40
  .byte $02

  .byte $96
  .byte $41
  .byte $0E
  .byte $00
  .byte $A0
  .byte $00
  .byte $40
  .byte $02

  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $32
  .byte $41
  .byte $00
  .byte $40
  .byte $F0
  .byte $00
  .byte $40
  .byte $02

  .byte $00
  .byte $81
  .byte $08
  .byte $00
  .byte $00
  .byte $00
  .byte $80
  .byte $01

  .byte $00
  .byte $11
  .byte $0D
  .byte $00
  .byte $00
  .byte $00
  .byte $10
  .byte $00

  .byte $90
  .byte $41
  .byte $0E
  .byte $00
  .byte $25
  .byte $00
  .byte $40
  .byte $02

  .byte $2E
  .byte $43
  .byte $00
  .byte $60
  .byte $F5
  .byte $00
  .byte $40
  .byte $04

  .byte $70
  .byte $41
  .byte $0A
  .byte $00
  .byte $40
  .byte $00
  .byte $40
  .byte $02

  .byte $00
  .byte $15
  .byte $03
  .byte $00
  .byte $00
  .byte $20
  .byte $14
  .byte $04

  .byte $40
  .byte $41
  .byte $00
  .byte $90
  .byte $01
  .byte $00
  .byte $40
  .byte $00

  .byte $00
  .byte $15
  .byte $EE
  .byte $00
  .byte $00
  .byte $00
  .byte $14
  .byte $00

  .byte $98
  .byte $41
  .byte $09
  .byte $00
  .byte $00
  .byte $00
  .byte $40
  .byte $01

  .byte $21
  .byte $41
  .byte $0A
  .byte $00
  .byte $30
  .byte $00
  .byte $40
  .byte $06

  .byte $21
  .byte $41
  .byte $0A
  .byte $00
  .byte $30
  .byte $00
  .byte $40
  .byte $06

  .byte $31
  .byte $41
  .byte $0E
  .byte $00
  .byte $10
  .byte $00
  .byte $40
  .byte $02

  .byte $23
  .byte $41
  .byte $00
  .byte $A0
  .byte $50
  .byte $00
  .byte $40
  .byte $00

  .byte $91
  .byte $41
  .byte $0A
  .byte $00
  .byte $30
  .byte $00
  .byte $40
  .byte $06

  .byte $F1
  .byte $41
  .byte $0C
  .byte $00
  .byte $40
  .byte $00
  .byte $40
  .byte $06

;=================================
; instruments part 2
; 0: oscillating frequency value (for pitch)
; 1: length of vibrato intensity (for vibrato)
; 2: Control register for effect 4
; 3: portamento value        |
; 4: portamento flag (1=on)  | portamento for the instrument
; 5: duration cycle for effect 1
; 6: not used
; 7: not used
;=================================

instr2:
  .byte $00
  .byte $00
  .byte $11                       ; Control: ^, on ADS
  .byte $00                       ; portamento value
  .byte $00                       ; portamento flag
  .byte $03
  .byte $00                       ; not used
  .byte $00                       ; not used

  .byte $00
  .byte $00
  .byte $81
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $06
  .byte $50
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $30
  .byte $02
  .byte $81
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $40
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $81
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $11
  .byte $41
  .byte $01
  .byte $01
  .byte $00
  .byte $00

  .byte $50
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $81
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $20
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $81
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $40
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $41
  .byte $F0
  .byte $01
  .byte $01
  .byte $00
  .byte $00

  .byte $10
  .byte $02
  .byte $43
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $A0
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $60
  .byte $02
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $00
  .byte $00
  .byte $43
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

  .byte $0A
  .byte $02
  .byte $43
  .byte $00
  .byte $00
  .byte $00
  .byte $00
  .byte $00

effect1:
       lda  freqHi1Eff,x          ; Voice 1: Frequency control (hi byte) for effect 1
       beq  noDec
       dec  freqHi1Eff,x          ; Voice 1: Frequency control (hi byte) for effect 1
noDec:
       lda  cycleInt,x
       beq  jmpTestEndCycle

       dec  cycleInt,x
       lda  #$81                  ; noise + ADS
       sta  $D404,x               ; Voice 1: Control registers
       lda  freqHi1Eff,x          ; Voice 1: Frequency control (hi byte) for effect 1
       eor  #$23
       sta  $D401,x               ; Voice 1: Frequency control (hi byte)
       jmp  decCycleTimer

jmpTestEndCycle:
       jmp  testEndCycle

changeFreq:
       lda  freqPortHi,x          ; Voice 1: Frequency control (hi byte) for portamento
       sta  $D401,x               ; Voice 1: Frequency control (hi byte)
       sta  freqHi1Eff,x          ; Voice 1: Frequency control (hi byte) for effect 1
       lda  instr2+2,y            ; control register
       sta  $D404,x               ; Voice 1: Control registers
       jmp  decCycleTimer

testEndCycle:
       lda  cycleEst,x
       cmp  instr2+5,y            ; duration cycle for effect 1
       beq  resetCycle

       inc  cycleInt,x
       inc  cycleEst,x
       bne  changeFreq

resetCycle:
       lda  #$00
       sta  cycleEst,x
       sta  cycleInt,x
       beq  changeFreq

songSpeed:                      ; cycle for having note tick (for each songs)
  .byte $00
  .byte $03
  .byte $03

; $FF:  repeat the track
; $FE:  end of music

drillerMainTr1:
  .byte $01, $01, $07, $09
  .byte $09, $09, $01, $07
  .byte $07, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $03
  .byte $03, $0F, $0F, $13
  .byte $13, $0F, $13, $0F
  .byte $13, $0F, $13, $0F
  .byte $13, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $0F, $0F
  .byte $0F, $0F, $1B, $1D
  .byte $1E, $0F, $1B, $1D
  .byte $1E, $0F, $1B, $1D
  .byte $1E, $12, $12, $12
  .byte $12, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $24, $24, $21
  .byte $21, $08, $08, $28
  .byte $00, $00, $00, $00
  .byte $00, $FF

drillerMainTr2:
  .byte $03, $03, $08, $0A
  .byte $0D, $0D, $0D, $0D
  .byte $08, $07, $0E, $0E
  .byte $0E, $0E, $0E, $0E
  .byte $0E, $0E, $05, $12
  .byte $12, $12, $12, $14
  .byte $15, $14, $15, $14
  .byte $15, $14, $15, $08
  .byte $17, $17, $17, $17
  .byte $17, $17, $17, $17
  .byte $17, $17, $17, $17
  .byte $07, $07, $1F, $1F
  .byte $1F, $1F, $07, $07
  .byte $00, $00, $25, $25
  .byte $26, $25, $27, $27
  .byte $27, $27, $27, $27
  .byte $27, $27, $06, $06
  .byte $06, $06, $06, $06
  .byte $06, $06, $06, $06
  .byte $28, $00, $00, $00
  .byte $00, $FF

drillerMainTr3:
  .byte $00, $00, $00, $00
  .byte $04, $06, $06, $0C
  .byte $0B, $0C, $0B, $0C
  .byte $0B, $06, $06, $06
  .byte $06, $06, $06, $06
  .byte $06, $06, $06, $06
  .byte $06, $06, $06, $0F
  .byte $0F, $10, $11, $0E
  .byte $0E, $0E, $0E, $0E
  .byte $0E, $0E, $0E, $0E
  .byte $0E, $0E, $0E, $16
  .byte $07, $07, $07, $18
  .byte $19, $19, $1A, $1A
  .byte $08, $08, $1C, $08
  .byte $08, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $23, $23, $22
  .byte $22, $07, $07, $0F
  .byte $0F, $0F, $0F, $29
  .byte $00, $00, $00, $00
  .byte $FF

;=================================
; pattern data
;=================================

; format:
; xx             : note xx
; $FA  nn        : select instrument nn
; $FB  mm        : negative portamento (mm)
; $FC  kk        : positive portamento (kk)
; $FD  kk        : duration kk
; $FF            : end of pattern


pnt00:
  .byte $FD, $3F
  .byte $FA, $04
  .byte $00
  .byte $FF

pnt01:
  .byte $FA, $01
  .byte $FD, $3F
  .byte $23, $1F, $22, $1E
  .byte $FF

pnt03:
  .byte $FA, $01
  .byte $FD, $3F
  .byte $17, $13, $16, $12
  .byte $FF

pnt02:
   .byte $FD, $0F
   .byte $FA, $04
   .byte $00
   .byte $FF

pnt04:
   .byte $FA, $02
   .byte $FD, $7F
   .byte $25, $25
   .byte $FF

pnt05:
   .byte $FA, $0E
   .byte $FD, $3F
   .byte $2F, $2B, $2E
   .byte $FC, $20
   .byte $2A
   .byte $FF

pnt06:
   .byte $FA, $06
   .byte $FD, $01
   .byte $42, $3B, $3B, $42
   .byte $3B, $3B, $43, $3B
   .byte $42, $3B, $3B, $42
   .byte $3B, $3B, $43, $3B
   .byte $42, $3B, $3B, $42
   .byte $3B, $3B, $43, $3B
   .byte $42, $3B, $3B, $42
   .byte $3B, $3B, $43, $3B
   .byte $FF

pnt07:
   .byte $FA, $01
   .byte $FD, $7F
   .byte $23
   .byte $FF

pnt08:
   .byte $FA, $01
   .byte $FD, $7F
   .byte $17, $00
   .byte $FF

pnt09:
   .byte $FA, $09
   .byte $FD, $1F
   .byte $17, $13, $12, $0F
   .byte $FF

pnt0A:
   .byte $FA, $08
   .byte $FD, $0F
   .byte $3E, $39
   .byte $FD, $1F
   .byte $3B
   .byte $FD, $0F
   .byte $3D, $3B
   .byte $FD, $1F
   .byte $3A
   .byte $FD, $7F
   .byte $FB, $01
   .byte $2F
   .byte $FF

pnt0B:
   .byte $FA, $06
   .byte $FD, $01
   .byte $3D, $36, $36, $3D
   .byte $36, $36, $3E, $36
   .byte $3D, $36, $36, $3D
   .byte $36, $36, $3E, $36
   .byte $3A, $33, $33, $3A
   .byte $33, $33, $3B, $33
   .byte $3A, $33, $33, $3A
   .byte $33, $33, $3B, $33
   .byte $FF

pnt0C:
  .byte $FA, $06
  .byte $FD, $01
  .byte $42, $3B, $3B, $42
  .byte $3B, $3B, $43, $3B
  .byte $42, $3B, $3B, $42
  .byte $3B, $3B, $43, $3B
  .byte $3E, $37, $37, $3E
  .byte $37, $37, $3F, $37
  .byte $3E, $37, $37, $3E
  .byte $37, $37, $3F, $37
  .byte $FF

pnt0D:
  .byte $FA, $0A
  .byte $FD, $01
  .byte $3B, $3A, $39, $38
  .byte $39, $3A, $3B, $3A
  .byte $39, $38, $39, $3A
  .byte $3B, $3A, $39, $38
  .byte $39, $3A, $3B, $3A
  .byte $39, $38, $39, $3A
  .byte $3B, $3A, $39, $38
  .byte $39, $3A, $3B, $3A
  .byte $FF

pnt0E:
  .byte $FA, $07
  .byte $FD, $01
  .byte $2D
  .byte $FD, $03
  .byte $2D
  .byte $FD, $0D
  .byte $2D
  .byte $FD, $03
  .byte $2D
  .byte $FD, $07
  .byte $FA, $00
  .byte $2D
  .byte $FA, $07
  .byte $FD, $01
  .byte $2D
  .byte $FD, $03
  .byte $2D
  .byte $FD, $0D
  .byte $2D
  .byte $FD, $03
  .byte $2D
  .byte $FD, $07
  .byte $FA, $00
  .byte $2D
  .byte $FF

pnt0F:
  .byte $FA, $0B
  .byte $FD, $01
  .byte $23, $23, $23, $23
  .byte $23, $23, $23, $23
  .byte $23, $23, $23, $23
  .byte $23, $23, $23, $23
  .byte $23, $23, $23, $23
  .byte $23, $23, $23, $23
  .byte $23, $23, $23, $23
  .byte $23, $23, $23, $23
  .byte $FF

pnt10:
  .byte $FA, $0B
  .byte $FD, $01
  .byte $22, $22, $22, $22
  .byte $22, $22, $22, $22
  .byte $22, $22, $22, $22
  .byte $22, $22, $22, $22
  .byte $22, $22, $22, $22
  .byte $22, $22, $22, $22
  .byte $22, $22, $22, $22
  .byte $22, $22, $22, $22
  .byte $FF

pnt11:
   .byte $FA, $0B
   .byte $FD, $01
   .byte $25, $25, $25, $25
   .byte $25, $25, $25, $25
   .byte $25, $25, $25, $25
   .byte $25, $25, $25, $25
   .byte $25, $25, $25, $25
   .byte $25, $25, $25, $25
   .byte $25, $25, $25, $25
   .byte $25, $25, $25, $25
   .byte $FF

pnt12:
  .byte $FA, $0A
  .byte $FD, $01
  .byte $3B, $37, $36, $34
  .byte $3B, $37, $36, $34
  .byte $3B, $37, $36, $34
  .byte $3B, $37, $36, $34
  .byte $3B, $37, $36, $34
  .byte $3B, $37, $36, $34
  .byte $3B, $37, $36, $34
  .byte $3B, $37, $36, $34
  .byte $FF

pnt13:
  .byte $FA, $0B
  .byte $FD, $01
  .byte $1F, $1F, $1F, $1F
  .byte $1F, $1F, $1F, $1F
  .byte $1F, $1F, $1F, $1F
  .byte $1F, $1F, $1F, $1F
  .byte $1F, $1F, $1F, $1F
  .byte $1F, $1F, $1F, $1F
  .byte $1F, $1F, $1F, $1F
  .byte $1F, $1F, $1F, $1F
  .byte $FF

pnt14:
  .byte $FA, $06
  .byte $FD, $01
  .byte $3F, $3B, $36, $3F
  .byte $3B, $36, $3F, $3B
  .byte $3F, $3B, $36, $3F
  .byte $3B, $36, $3F, $3B
  .byte $3F, $3B, $36, $3F
  .byte $3B, $36, $3F, $3B
  .byte $3F, $3B, $36, $3F
  .byte $3B, $36, $3F, $3B
  .byte $FF

pnt15:
  .byte $FA, $06
  .byte $FD, $01
  .byte $3E, $3B, $37, $3E
  .byte $3B, $37, $3E, $3B
  .byte $3E, $3B, $37, $3E
  .byte $3B, $37, $3E, $3B
  .byte $3E, $3B, $37, $3E
  .byte $3B, $37, $3E, $3B
  .byte $3E, $3B, $37, $3E
  .byte $3B, $37, $3E, $3B
  .byte $FF

pnt16:
  .byte $FA, $0D
  .byte $FD, $1F
  .byte $37, $36, $39, $37
  .byte $36, $2F, $2F, $32
  .byte $FF

pnt17:
  .byte $FA, $10
  .byte $FD, $01
  .byte $23, $23, $2A, $2A
  .byte $28, $28, $2A, $2A
  .byte $26, $26, $2A, $2A
  .byte $28, $28, $2A, $2A
  .byte $23, $23, $2A, $2A
  .byte $28, $28, $2A, $2A
  .byte $26, $26, $2A, $2A
  .byte $28, $28, $2A, $2A
  .byte $FF

pnt18:
  .byte $FA, $13
  .byte $FD, $07
  .byte $FC, $37, $45
  .byte $FD, $2F
  .byte $47
  .byte $FD, $07
  .byte $FB, $7F, $47
  .byte $FD, $37
  .byte $42
  .byte $FD, $07
  .byte $FB, $80
  .byte $42
  .byte $FF

pnt19:
  .byte $FA, $13
  .byte $FD, $1F
  .byte $3B
  .byte $FD, $0F
  .byte $39, $37
  .byte $FD, $3F
  .byte $36
  .byte $FF

pnt1A:
  .byte $FA, $13
  .byte $FD, $1F
  .byte $34
  .byte $FD, $0F
  .byte $32, $31
  .byte $FD, $3F
  .byte $2F
  .byte $FF

pnt1B:
  .byte $FA, $0B
  .byte $FD, $01
  .byte $1B, $1B, $1B, $1B
  .byte $1B, $1B, $1B, $1B
  .byte $1B, $1B, $1B, $1B
  .byte $1B, $1B, $1B, $1B
  .byte $1B, $1B, $1B, $1B
  .byte $1B, $1B, $1B, $1B
  .byte $1B, $1B, $1B, $1B
  .byte $1B, $1B, $1B, $1B
  .byte $FF

pnt1C:
  .byte $FA, $01
  .byte $FD, $1F
  .byte $3B
  .byte $FD, $0F
  .byte $3A, $36
  .byte $FD, $2F
  .byte $36
  .byte $FD, $0F
  .byte $38
  .byte $FD, $1F
  .byte $38, $2F, $31
  .byte $FD, $0F
  .byte $33, $34
  .byte $FD, $7F
  .byte $36, $36
  .byte $FF

pnt1D:
  .byte $FA, $0B
  .byte $FD, $01
  .byte $1C, $1C, $1C, $1C
  .byte $1C, $1C, $1C, $1C
  .byte $1C, $1C, $1C, $1C
  .byte $1C, $1C, $1C, $1C
  .byte $1C, $1C, $1C, $1C
  .byte $1C, $1C, $1C, $1C
  .byte $1C, $1C, $1C, $1C
  .byte $1C, $1C, $1C, $1C
  .byte $FF

pnt1E:
  .byte $FA, $0B
  .byte $FD, $01
  .byte $1E, $1E, $1E, $1E
  .byte $1E, $1E, $1E, $1E
  .byte $1E, $1E, $1E, $1E
  .byte $1E, $1E, $1E, $1E
  .byte $1E, $1E, $1E, $1E
  .byte $1E, $1E, $1E, $1E
  .byte $1E, $1E, $1E, $1E
  .byte $1E, $1E, $1E, $1E
  .byte $FF

pnt1F:
  .byte $FA, $09
  .byte $FD, $3F
  .byte $23, $1B, $1C, $1E
  .byte $FF

pnt20:
  .byte $FA, $01
  .byte $FD, $7F
  .byte $17, $17
  .byte $FF

  .byte $21, $26
  .byte $FD, $11
  .byte $28
  .byte $FF

pnt21:
  .byte $FA, $15
  .byte $FD, $01
  .byte $1F, $1F
  .byte $FD, $03
  .byte $1F
  .byte $FA, $0F
  .byte $FD, $01
  .byte $2E, $27
  .byte $FA, $15
  .byte $1F
  .byte $FD, $03
  .byte $1F
  .byte $FD, $01
  .byte $1F
  .byte $FD, $03
  .byte $1F
  .byte $FD, $01
  .byte $FA, $0F
  .byte $2F
  .byte $FA, $15
  .byte $1A, $1D, $1F
  .byte $FF

pnt22:
  .byte $FA, $09
  .byte $FD, $01
  .byte $13, $13
  .byte $FD, $03
  .byte $13
  .byte $FD, $01
  .byte $FA, $00
  .byte $2E, $27
  .byte $FA, $09
  .byte $13
  .byte $FD, $03
  .byte $13
  .byte $FD, $01
  .byte $13
  .byte $FD, $03
  .byte $13
  .byte $FD, $01
  .byte $13, $10, $11, $13
  .byte $FF

pnt23:
  .byte $FA, $09
  .byte $FD, $01
  .byte $17, $17
  .byte $FD, $03
  .byte $17
  .byte $FD, $01
  .byte $FA, $00
  .byte $2E, $27
  .byte $FA, $09
  .byte $17
  .byte $FD, $03
  .byte $17
  .byte $FD, $01
  .byte $17
  .byte $FD, $03
  .byte $17
  .byte $FD, $01
  .byte $17, $12, $15, $17
  .byte $FF

pnt24:
  .byte $FA, $15
  .byte $FD, $01
  .byte $23, $23
  .byte $FD, $03
  .byte $23
  .byte $FA, $0F
  .byte $FD, $01
  .byte $2E, $27
  .byte $FA, $15
  .byte $23
  .byte $FD, $03
  .byte $23
  .byte $FD, $01
  .byte $23
  .byte $FD, $03
  .byte $23
  .byte $FD, $01
  .byte $FA, $0F
  .byte $2F
  .byte $FA, $15
  .byte $1E, $21, $23
  .byte $FF

pnt25:
  .byte $FA, $0A
  .byte $FD, $39
  .byte $47
  .byte $FD, $01
  .byte $46, $45, $44
  .byte $FD, $39
  .byte $43
  .byte $FD, $01
  .byte $44, $45, $46
  .byte $FF

pnt26:
  .byte $FA, $12
  .byte $FD, $3F
  .byte $3B, $43, $42, $3E
  .byte $3B, $37, $36, $2F
  .byte $FF

pnt27:
  .byte $FA, $0C
  .byte $FD, $01
  .byte $31, $3D, $49, $3D
  .byte $31, $3D, $49, $3D
  .byte $FF

pnt28:
  .byte $FA, $01
  .byte $FD, $7F
  .byte $17, $00, $00, $00
  .byte $FF

pnt29:
  .byte $FA, $01
  .byte $FD, $7F
  .byte $23, $00, $00, $00
  .byte $FF

r157A:
  .byte <r157C

r157B:
  .byte >r157C

r157C:
  .byte $00, $0C, $18

;pointers to the patterns

;low pointers
patptl:
  .byte <pnt00
  .byte <pnt01
  .byte <pnt02
  .byte <pnt03
  .byte <pnt04
  .byte <pnt05
  .byte <pnt06
  .byte <pnt07
  .byte <pnt08
  .byte <pnt09
  .byte <pnt0A
  .byte <pnt0B
  .byte <pnt0C
  .byte <pnt0D
  .byte <pnt0E
  .byte <pnt0F
  .byte <pnt10
  .byte <pnt11
  .byte <pnt12
  .byte <pnt13
  .byte <pnt14
  .byte <pnt15
  .byte <pnt16
  .byte <pnt17
  .byte <pnt18
  .byte <pnt19
  .byte <pnt1A
  .byte <pnt1B
  .byte <pnt1C
  .byte <pnt1D
  .byte <pnt1E
  .byte <pnt1F
  .byte <pnt20
  .byte <pnt21
  .byte <pnt22
  .byte <pnt23
  .byte <pnt24
  .byte <pnt25
  .byte <pnt26
  .byte <pnt27
  .byte <pnt28
  .byte <pnt29

;high pointers

patpth:
  .byte >pnt00
  .byte >pnt01
  .byte >pnt02
  .byte >pnt03
  .byte >pnt04
  .byte >pnt05
  .byte >pnt06
  .byte >pnt07
  .byte >pnt08
  .byte >pnt09
  .byte >pnt0A
  .byte >pnt0B
  .byte >pnt0C
  .byte >pnt0D
  .byte >pnt0E
  .byte >pnt0F
  .byte >pnt10
  .byte >pnt11
  .byte >pnt12
  .byte >pnt13
  .byte >pnt14
  .byte >pnt15
  .byte >pnt16
  .byte >pnt17
  .byte >pnt18
  .byte >pnt19
  .byte >pnt1A
  .byte >pnt1B
  .byte >pnt1C
  .byte >pnt1D
  .byte >pnt1E
  .byte >pnt1F
  .byte >pnt20
  .byte >pnt21
  .byte >pnt22
  .byte >pnt23
  .byte >pnt24
  .byte >pnt25
  .byte >pnt26
  .byte >pnt27
  .byte >pnt28
  .byte >pnt29

songs:
  .byte $00
  .byte <drillerMainTr1
  .byte $00
  .byte >drillerMainTr1
  .byte $00
  .byte <drillerMainTr2
  .byte $00
  .byte >drillerMainTr2
  .byte $00
  .byte <drillerMainTr3
  .byte $00
  .byte >drillerMainTr3
  .byte $00

initsongs:
      lda  #$01             ; first song
      sta  songsNumber
      rts




